package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.database.dto.NasaDataRecordPage;
import org.jeecg.modules.database.entity.HistoricalDatabase;
import org.jeecg.modules.database.service.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.Arrays;

/**
 * @Description: 历史一期记录
 * @Author: jeecg-boot
 * @Date: 2025-02-24
 * @Version: V1.0
 */
@Tag(name = "历史一期记录")
@RestController
@RequestMapping("/database/historicalDatabase")
@Slf4j
public class HistoricalDatabaseController extends JeecgController<HistoricalDatabase, IHistoricalDatabaseService> {
    @Autowired
    private IHistoricalDatabaseService historicalDatabaseService;
    @Autowired
    private ILocalDatabaseService      localDatabaseService;
    @Autowired
    private INasaDataRecordService     nasaDataRecordService;

    /**
     * 分页列表查询
     *
     * @param historicalDatabase
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "历史一期记录-分页列表查询")
    @Operation(summary = "历史一期记录-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<HistoricalDatabase>> queryPageList(HistoricalDatabase historicalDatabase,
                                                           @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                           @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                           HttpServletRequest req) {
        QueryWrapper<HistoricalDatabase> queryWrapper = QueryGenerator.initQueryWrapper(historicalDatabase, req.getParameterMap());
        Page<HistoricalDatabase> page = new Page<HistoricalDatabase>(pageNo, pageSize);
        IPage<HistoricalDatabase> pageList = historicalDatabaseService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param historicalDatabase
     * @return
     */
    @AutoLog(value = "历史一期记录-添加")
    @Operation(summary = "历史一期记录-添加")
    @RequiresPermissions("database:historical_database:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody HistoricalDatabase historicalDatabase) {
        historicalDatabaseService.save(historicalDatabase);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param historicalDatabase
     * @return
     */
    @AutoLog(value = "历史一期记录-编辑")
    @Operation(summary = "历史一期记录-编辑")
    @RequiresPermissions("database:historical_database:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody HistoricalDatabase historicalDatabase) {
        historicalDatabaseService.updateById(historicalDatabase);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "历史一期记录-通过id删除")
    @Operation(summary = "历史一期记录-通过id删除")
    @RequiresPermissions("database:historical_database:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        historicalDatabaseService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "历史一期记录-批量删除")
    @Operation(summary = "历史一期记录-批量删除")
    @RequiresPermissions("database:historical_database:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.historicalDatabaseService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "历史一期记录-通过id查询")
    @Operation(summary = "历史一期记录-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<HistoricalDatabase> queryById(@RequestParam(name = "id", required = true) String id) {
        HistoricalDatabase historicalDatabase = historicalDatabaseService.getById(id);
        if (historicalDatabase == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(historicalDatabase);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param historicalDatabase
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HistoricalDatabase historicalDatabase) {
        return super.exportXls(request, historicalDatabase, HistoricalDatabase.class, "历史一期记录");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:historical_database:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, HistoricalDatabase.class);
    }

    @Operation(summary = "历史数据统计")
    @GetMapping(value = "/statistics")
    public Result<NasaDataRecordPage> statistics() {
        NasaDataRecordPage result = new NasaDataRecordPage();
        Long nasaCountLhs = nasaDataRecordService.sumLhs();
        Long nasaCountXhy = nasaDataRecordService.sumXhy();
        Long historicalCountLhs = historicalDatabaseService.sumLhs();
        Long historicalCountXhy = historicalDatabaseService.sumXhy();
        Long localCountLhs = localDatabaseService.sumLhs();
        Long localCountXhy = localDatabaseService.sumXhy();

        result.setLhsCount(historicalCountLhs);
        result.setLhsTotal(nasaCountLhs + localCountLhs + historicalCountLhs);
        result.setXhyCount(historicalCountXhy);
        result.setXyhTotal(nasaCountXhy + localCountXhy + historicalCountXhy);

        return Result.OK(result);
    }
}
